/* A RapidNet application. Generated by RapidNet compiler. */

#ifndef EMULSTRIGGERED_H
#define EMULSTRIGGERED_H

#include <string>
#include <iostream>
#include "ns3/ptr.h"
#include "ns3/event-id.h"
#include "ns3/ipv4-address.h"
#include "ns3/rapidnet-header.h"
#include "ns3/relation-base.h"
#include "ns3/database.h"
#include "ns3/rapidnet-application-base.h"
#include "ns3/aggregator.h"
#include "ns3/aggwrap.h"

using namespace std;
using namespace ns3;

namespace ns3 {

class Socket;
class Packet;

namespace rapidnet {
namespace emulstriggered {

class EmuLsTriggered : public RapidNetApplicationBase
{
public:
  static const string APPTABLE;
  static const string ELSU;
  static const string ELSUCHANGE;
  static const string ELSUCOUNT;
  static const string ELSUDEL;
  static const string ELSUFILTERED;
  static const string ELSULOC;
  static const string ELINKADD;
  static const string ELINKCOUNT;
  static const string PERIODIC;
  static const string R11_ECAPERIODIC;
  static const string R61A_ECAPERIODIC;
  static const string R61B_ECAPERIODIC;
  static const string TLSU;
  static const string TLINK;

  static TypeId GetTypeId (void);

  EmuLsTriggered ();

  virtual ~EmuLsTriggered ();

protected:

  virtual void DoDispose (void);

  virtual void StartApplication (void);

  virtual void StopApplication (void);

  virtual void InitDatabase (void);

  virtual void DemuxRecv (Ptr<Tuple> tuple);

  virtual void R11_ecaperiodic ();

  virtual void R11_eca (Ptr<Tuple> r11_ecaperiodic);

  virtual void R33_eca (Ptr<Tuple> eLinkAdd);

  virtual void R34_eca (Ptr<Tuple> eLinkCount);

  virtual void R35_eca (Ptr<Tuple> eLinkAdd);

  virtual void R61A_ecaperiodic ();

  virtual void R61A_eca (Ptr<Tuple> r61A_ecaperiodic);

  virtual void R61B_ecaperiodic ();

  virtual void R61B_eca (Ptr<Tuple> r61B_ecaperiodic);

  virtual void RAddEca2Ins (Ptr<Tuple> tLink);

  virtual void RAddEca2Ref (Ptr<Tuple> tLink);

  virtual void R70_eca (Ptr<Tuple> eLSU);

  virtual void RFilter_eca (Ptr<Tuple> eLSULoc);

  virtual void R71_eca (Ptr<Tuple> eLSUFiltered);

  virtual void R72_eca (Ptr<Tuple> eLSUCount);

  virtual void R73_eca (Ptr<Tuple> eLSUFiltered);

  virtual void R74_eca (Ptr<Tuple> eLSUCount);

  virtual void R75_eca (Ptr<Tuple> eLSUDel);

  virtual void R81Eca0Ins (Ptr<Tuple> tLSU);

  virtual void R81Eca0Ref (Ptr<Tuple> tLSU);

  virtual void R82_eca (Ptr<Tuple> eLSUChange);

  virtual void R83_eca (Ptr<Tuple> eLSUDel);

  EventId m_event_r11_ecaperiodic;
  EventId m_event_r61a_ecaperiodic;
  EventId m_event_r61b_ecaperiodic;
};

} // namespace emulstriggered
} // namespace rapidnet
} // namespace ns3

#endif // EMULSTRIGGERED_H
